<template>
  <div class="the-number">
    <input
      type="number"
      ref="input"
      :id="id"
      :value="value"
      :min="min"
      :max="max"
      :step="step"
      @keydown="onKeyDown"
      @input="onInput"
      @focus="onFocus"
    />
    <div class="the-trigger" @click="onClick">{{value | amount}}</div>
    <div class="the-command" @mousedown="onCommand">{{commandTitle}}</div>
  </div>
</template>

<script>
  export default {
    name: "Number",
    props: {
      /**
       * Идентификатор элемента input
       * для возможности привязать его к label.
       */
      id: String,
      /**
       * Минимальное значение.
       */
      min: {
        type: Number,
        default: 0,
      },
      /**
       * Максимальное значение.
       */
      max: {
        type: Number,
        default: Number.MAX_SAFE_INTEGER,
      },
      /**
       * Шаг инкремента / декримента значения.
       */
      step: {
        type: Number,
        default: 1,
      },
      /**
       * Значение.
       */
      value: {
        type: Number,
        required: true
      },
      /**
       * Заголовок кнопки команды.
       */
      commandTitle: {
        type: String,
        validator: function (value) {
          return value !== '';
        }
      }
    },
    data() {
      return {
        initialValue: this.value
      }
    },
    filters: {
      /**
       * Фильтр для форматирования суммы.
       * @param value
       * @returns {string}
       */
      amount: function (value) {
        return value.toString().split('').reverse().reduce((accum, item, index) => {
          return accum.push(item) && ((index + 1) % 3 !== 0 || accum.push(' ')) && accum;
        }, []).reverse().join('');
      },
    },
    methods: {
      onClick() {
        this.$refs.input.focus();
        this.$refs.input.select();
      },
      onCommand() {
        this.$emit('command');
      },
      onFocus() {
        this.initialValue = this.value;
      },
      onKeyDown(event) {
        if([',', '.'].includes(event.key)) {
          event.preventDefault();
        }
        else if(event.key === 'Escape') {
          this.$emit('input', this.initialValue);
          this.$refs.input.blur();
        }
        else if(event.key === 'Enter') {
          if(event.ctrlKey) {
            this.$emit('command');
          }

          this.$refs.input.blur();
        }
      },
      onInput(event) {
        let value = parseInt(event.target.value) || 0;
        if(value > this.max)
          value = this.max;
        if(value.toString() !== event.target.value)
          event.target.value = value;

        this.$emit('input', value);
      }
    }
  }
</script>

<style lang="scss" scoped>
.the-number {
  position: relative;
  display: inline-block;
  .the-trigger, input {
    font-size: 1.4rem;
    font-weight: normal;
    color: #2E2E2E;
    padding: 0.4rem 0.6rem;
    border: 1px solid transparent;
    outline: none;
  }

  .the-trigger {
    position: absolute;
    display: block;
    left: 0;
    top: 0;
    white-space: nowrap;
    padding-right: 1.4rem;
    &::after {
      content: "\2304";
      position: absolute;
      right: 0;
      top: 0.2rem;
    }
    &:hover {
      color: #00b1ed;
      cursor: text;
    }
  }

  .the-command {
    position: absolute;
    display: none;
    bottom: 0.2rem;
    cursor: pointer;
  }

  input {
    width: 0;
    padding-right: 0;
    margin-bottom: 1.2rem;
    &:focus {
      width: initial;
      border: 1px solid #7e7e7e;
      & + .the-trigger {
        display: none;
      }
      & + .the-trigger + .the-command {
        display: block;
      }
    }
  }
  .the-command {
    font-size: 1rem;
    padding-left: 0.6rem;
    color: #00b1ed;
  }
}
</style>